Index: trunk/source/App/TAppEncoder/TAppEncTop.cpp
===================================================================
--- trunk/source/App/TAppEncoder/TAppEncTop.cpp	(revision 55)
+++ trunk/source/App/TAppEncoder/TAppEncTop.cpp	(revision 125)
@@ -581,11 +610,41 @@
   m_cTEncTop.setChromaSampleLocTypeBottomField( m_chromaSampleLocTypeBottomField );
   m_cTEncTop.setNeutralChromaIndicationFlag( m_neutralChromaIndicationFlag );
+  m_cTEncTop.setDefaultDisplayWindow( m_defDispWinLeftOffset, m_defDispWinRightOffset, m_defDispWinTopOffset, m_defDispWinBottomOffset );
+  m_cTEncTop.setFrameFieldInfoPresentFlag( m_frameFieldInfoPresentFlag );
+  m_cTEncTop.setPocProportionalToTimingFlag( m_pocProportionalToTimingFlag );
+  m_cTEncTop.setNumTicksPocDiffOneMinus1   ( m_numTicksPocDiffOneMinus1    );
   m_cTEncTop.setBitstreamRestrictionFlag( m_bitstreamRestrictionFlag );
   m_cTEncTop.setTilesFixedStructureFlag( m_tilesFixedStructureFlag );
   m_cTEncTop.setMotionVectorsOverPicBoundariesFlag( m_motionVectorsOverPicBoundariesFlag );
+  m_cTEncTop.setMinSpatialSegmentationIdc( m_minSpatialSegmentationIdc );
   m_cTEncTop.setMaxBytesPerPicDenom( m_maxBytesPerPicDenom );
   m_cTEncTop.setMaxBitsPerMinCuDenom( m_maxBitsPerMinCuDenom );
   m_cTEncTop.setLog2MaxMvLengthHorizontal( m_log2MaxMvLengthHorizontal );
   m_cTEncTop.setLog2MaxMvLengthVertical( m_log2MaxMvLengthVertical );
+#if SIGNAL_BITRATE_PICRATE_IN_VPS
+  TComBitRatePicRateInfo *bitRatePicRateInfo = m_cTEncTop.getVPS()->getBitratePicrateInfo();
+  // The number of bit rate/pic rate have to equal to number of sub-layers.
+  if(m_bitRatePicRateMaxTLayers)
+  {
+    assert(m_bitRatePicRateMaxTLayers == m_cTEncTop.getVPS()->getMaxTLayers());
+  }
+  for(Int i = 0; i < m_bitRatePicRateMaxTLayers; i++)
+  {
+    bitRatePicRateInfo->setBitRateInfoPresentFlag( i, m_bitRateInfoPresentFlag[i] );
+    if( bitRatePicRateInfo->getBitRateInfoPresentFlag(i) )
+    {
+      bitRatePicRateInfo->setAvgBitRate(i, m_avgBitRate[i]);
+      bitRatePicRateInfo->setMaxBitRate(i, m_maxBitRate[i]);
+    }
+  }
+  for(Int i = 0; i < m_bitRatePicRateMaxTLayers; i++)
+  {
+    bitRatePicRateInfo->setPicRateInfoPresentFlag( i, m_picRateInfoPresentFlag[i] );
+    if( bitRatePicRateInfo->getPicRateInfoPresentFlag(i) )
+    {
+      bitRatePicRateInfo->setAvgPicRate     (i, m_avgPicRate[i]);
+      bitRatePicRateInfo->setConstantPicRateIdc(i, m_constantPicRateIdc[i]);
+    }
+  }
 #endif
 }
@@ -601,10 +660,10 @@
   for(UInt layer=0; layer<m_numLayers; layer++)
   {
-    m_acTVideoIOYuvInputFile[layer].open( (char *)m_acLayerCfg[layer].getInputFile().c_str(),  false, m_uiInputBitDepth, m_uiInternalBitDepth );  // read  mode
+    m_acTVideoIOYuvInputFile[layer].open( (Char *)m_acLayerCfg[layer].getInputFile().c_str(),  false, m_inputBitDepthY, m_inputBitDepthC, m_internalBitDepthY, m_internalBitDepthC );  // read  mode
     m_acTVideoIOYuvInputFile[layer].skipFrames(m_FrameSkip, m_acLayerCfg[layer].getSourceWidth() - m_acLayerCfg[layer].getPad()[0], m_acLayerCfg[layer].getSourceHeight() - m_acLayerCfg[layer].getPad()[1]);
 
     if (!m_acLayerCfg[layer].getReconFile().empty())
     {
-      m_acTVideoIOYuvReconFile[layer].open((char *)m_acLayerCfg[layer].getReconFile().c_str(), true, m_uiOutputBitDepth, m_uiInternalBitDepth);  // write mode
+      m_acTVideoIOYuvReconFile[layer].open((Char *)m_acLayerCfg[layer].getReconFile().c_str(), true, m_outputBitDepthY, m_outputBitDepthC, m_internalBitDepthY, m_internalBitDepthC );  // write mode
     }
 
@@ -612,10 +671,10 @@
   }
 #else
-  m_cTVideoIOYuvInputFile.open( m_pchInputFile,     false, m_uiInputBitDepth, m_uiInternalBitDepth );  // read  mode
+  m_cTVideoIOYuvInputFile.open( m_pchInputFile,     false, m_inputBitDepthY, m_inputBitDepthC, m_internalBitDepthY, m_internalBitDepthC );  // read  mode
   m_cTVideoIOYuvInputFile.skipFrames(m_FrameSkip, m_iSourceWidth - m_aiPad[0], m_iSourceHeight - m_aiPad[1]);
 
   if (m_pchReconFile)
-    m_cTVideoIOYuvReconFile.open(m_pchReconFile, true, m_uiOutputBitDepth, m_uiInternalBitDepth);  // write mode
-  
+    m_cTVideoIOYuvReconFile.open(m_pchReconFile, true, m_outputBitDepthY, m_outputBitDepthC, m_internalBitDepthY, m_internalBitDepthC);  // write mode
+
   // Neo Decoder
   m_cTEncTop.create();
@@ -640,5 +699,5 @@
   m_cTVideoIOYuvInputFile.close();
   m_cTVideoIOYuvReconFile.close();
-  
+
   // Neo Decoder
   m_cTEncTop.destroy();
@@ -653,4 +712,94 @@
     m_acTEncTop[layer].init();
   }
+#if VPS_RENAME
+  m_acTEncTop[0].getVPS()->setMaxLayers( m_numLayers );
+#endif
+#if VPS_EXTN_OP_LAYER_SETS
+  TComVPS* vps = m_acTEncTop[0].getVPS();
+  vps->setMaxLayerId(m_numLayers - 1);    // Set max-layer ID
+
+  vps->setNumLayerSets(m_numLayers);
+  for(Int setId = 1; setId < vps->getNumLayerSets(); setId++)
+  {
+    for(Int layerId = 0; layerId <= vps->getMaxLayerId(); layerId++)
+    {
+      vps->setLayerIdIncludedFlag(true, setId, layerId);
+    }
+  }
+#if VPS_EXTN_MASK_AND_DIM_INFO
+  UInt i = 0, dimIdLen = 0;
+  vps->setAvcBaseLayerFlag(false);
+  vps->setSplittingFlag(false);
+  for(i = 0; i < MAX_VPS_NUM_SCALABILITY_TYPES; i++)
+  {
+    vps->setScalabilityMask(i, false);
+  }
+  if(m_numLayers > 1) 
+  {
+    vps->setScalabilityMask(1, true); // Only turn on spatial/SNR scalability
+    vps->setNumScalabilityTypes(1);
+  }
+  else
+  {
+    vps->setNumScalabilityTypes(0);
+  }
+  while((1 << dimIdLen) < m_numLayers)
+  {
+    dimIdLen++;
+  }
+  vps->setDimensionIdLen(0, dimIdLen);
+  vps->setNuhLayerIdPresentFlag(false);
+  vps->setLayerIdInNuh(0, 0);
+  vps->setLayerIdInVps(0, 0);
+  for(i = 1; i < vps->getMaxLayers(); i++)
+  {
+    vps->setLayerIdInNuh(i, i);
+    vps->setLayerIdInVps(vps->getLayerIdInNuh(i), i);
+    vps->setDimensionId(i, 0, i);
+  }
+#endif
+#if VPS_EXTN_PROFILE_INFO
+  vps->getPTLForExtnPtr()->resize(vps->getNumLayerSets());
+  for(Int setId = 1; setId < vps->getNumLayerSets(); setId++)
+  {
+    vps->setProfilePresentFlag(setId, true);
+    // Note - may need to be changed for other layer structures.
+    *(vps->getPTLForExtn(setId)) = *(m_acTEncTop[setId].getSPS()->getPTL());
+  }
+#endif
+  // Target output layer
+  vps->setNumOutputLayerSets(1);
+  Int lsIdx = 1;
+  vps->setOutputLayerSetIdx(0, lsIdx); // Because only one layer set
+  // Include the highest layer as output layer 
+  for(UInt layer=0; layer <= vps->getMaxLayerId() ; layer++)
+  {
+    if(vps->getLayerIdIncludedFlag(lsIdx, layer))
+    {
+      vps->setOutputLayerFlag(lsIdx, layer, layer == (vps->getMaxLayerId()));
+    }
+  }
+#endif
+#if VPS_EXTN_DIRECT_REF_LAYERS
+  // Direct reference layers
+  for(UInt layerCtr = 1;layerCtr <= vps->getMaxLayers() - 1; layerCtr++)
+  {
+    vps->setNumDirectRefLayers( layerCtr, m_acTEncTop[layerCtr].getNumDirectRefLayers() );
+    for(i = 0; i < vps->getNumDirectRefLayers(layerCtr); i++)
+    {
+      vps->setRefLayerId( layerCtr, i, m_acTEncTop[layerCtr].getRefLayerId(i) );
+    }
+    // Set direct dependency flag
+    // Initialize flag to 0
+    for(Int refLayerCtr = 0; refLayerCtr < layerCtr; refLayerCtr++)
+    {
+      vps->setDirectDependencyFlag( layerCtr, refLayerCtr, false );
+    }
+    for(i = 0; i < vps->getNumDirectRefLayers(layerCtr); i++)
+    {
+      vps->setDirectDependencyFlag( layerCtr, vps->getLayerIdInVps(m_acTEncTop[layerCtr].getRefLayerId(i)), true);
+    }
+  }
+#endif
 #else
   m_cTEncTop.init();
@@ -663,18 +812,18 @@
 
 /**
- - create internal class
- - initialize internal variable
- - until the end of input YUV file, call encoding function in TEncTop class
- - delete allocated buffers
- - destroy internal class
- .
- */
+- create internal class
+- initialize internal variable
+- until the end of input YUV file, call encoding function in TEncTop class
+- delete allocated buffers
+- destroy internal class
+.
+*/
 #if SVC_EXTENSION
 Void TAppEncTop::encode()
 {
-  fstream bitstreamFile(m_pchBitstreamFile, fstream::binary | fstream::out);
+  fstream bitstreamFile(m_pBitstreamFile, fstream::binary | fstream::out);
   if (!bitstreamFile)
   {
-    fprintf(stderr, "\nfailed to open bitstream file `%s' for writing\n", m_pchBitstreamFile);
+    fprintf(stderr, "\nfailed to open bitstream file `%s' for writing\n", m_pBitstreamFile);
     exit(EXIT_FAILURE);
   }
@@ -682,7 +831,6 @@
   TComPicYuv*       pcPicYuvOrg [MAX_LAYERS];
   TComPicYuv*       pcPicYuvRec = NULL;
-  
+
   // initialize internal class & member variables
-
   xInitLibCfg();
   xCreateLib();
@@ -690,7 +838,7 @@
 
   // main encoder loop
-  Int   iNumEncoded, iTotalNumEncoded;
-  Bool  bEos = false, bBaseEos = false;
-  
+  Int   iNumEncoded = 0, iTotalNumEncoded = 0;
+  Bool  bEos = false;
+
   list<AccessUnit> outputAccessUnits; ///< list of access units to write out.  is populated by the encoding process
 
@@ -699,8 +847,8 @@
     // allocate original YUV buffer
     pcPicYuvOrg[layer] = new TComPicYuv;
-#if SVC_UPSAMPLING 
+#if SVC_UPSAMPLING
     pcPicYuvOrg[layer]->create( m_acLayerCfg[layer].getSourceWidth(), m_acLayerCfg[layer].getSourceHeight(), m_uiMaxCUWidth, m_uiMaxCUHeight, m_uiMaxCUDepth, NULL );
 #else
-    pcPicYuvOrg[layer]->create( m_acLayerCfg[layer].getSourceWidth(), m_acLayerCfg[layer].getSourceHeight(), m_uiMaxCUWidth, m_uiMaxCUHeight, m_uiMaxCUDepth );
+    pcPicYuvOrg->create( m_acLayerCfg[layer].getSourceWidth(), m_acLayerCfg[layer].getSourceHeight(), m_uiMaxCUWidth, m_uiMaxCUHeight, m_uiMaxCUDepth );
 #endif
   }
@@ -733,6 +881,7 @@
         xGetBuffer(pcPicYuvRec, layer);
 
+        // read input YUV file
         m_acTVideoIOYuvInputFile[layer].read( pcPicYuvOrg[layer], m_acLayerCfg[layer].getPad() );
-    
+
         if(layer == m_numLayers-1)
         {
@@ -740,16 +889,20 @@
           m_iFrameRcvd++;
           // check end of file
-          bEos = ( m_acTVideoIOYuvInputFile[layer].isEof() == 1 ?   true : bBaseEos? true : bEos  );
-          bEos = ( m_iFrameRcvd == m_iFrameToBeEncoded ?    true : bEos   );
+          bEos = (m_iFrameRcvd == m_framesToBeEncoded);
         }
-        else
-        {
-          // check end of file of base layers
-          bBaseEos = ( m_acTVideoIOYuvInputFile[layer].isEof() == 1 ?   true : bBaseEos  );
-        }
-        m_acTEncTop[layer].encodePrep( bEos, pcPicYuvOrg[layer] );
+
+        m_acTEncTop[layer].encodePrep( pcPicYuvOrg[layer] );
       }
 
       bFramesReadyToCode = !(!bFirstFrame && ( m_acTEncTop[m_numLayers-1].getNumPicRcvd() != m_iGOPSize && m_iGOPSize ) && !bEos );
+    }
+    Bool flush = 0;
+    // if end of file (which is only detected on a read failure) flush the encoder of any queued pictures
+    if (m_acTVideoIOYuvInputFile[m_numLayers-1].isEof())
+    {
+      flush = true;
+      bEos = true;
+      m_iFrameRcvd--;
+      m_acTEncTop[m_numLayers-1].setFramesToBeEncoded(m_iFrameRcvd);
     }
 
@@ -761,6 +914,5 @@
       {
         // call encoding function for one frame
-        m_acTEncTop[layer].encode( pcPicYuvOrg[layer], m_acListPicYuvRec[layer], 
-          outputAccessUnits, iPicIdInGOP );
+        m_acTEncTop[layer].encode( flush ? 0 : pcPicYuvOrg[layer], m_acListPicYuvRec[layer], outputAccessUnits, iPicIdInGOP );
       }
     }
@@ -771,5 +923,5 @@
       // write bistream to file if necessary
       iNumEncoded = m_acTEncTop[layer].getNumPicRcvd();
-      if ( iNumEncoded > 0 )  
+      if ( iNumEncoded > 0 )
       {
         xWriteRecon(layer, iNumEncoded);
@@ -794,5 +946,4 @@
     bFirstFrame = false;
   }
-
   // delete original YUV buffer
   for(UInt layer=0; layer<m_numLayers; layer++)
@@ -805,5 +956,5 @@
     m_acTEncTop[layer].deletePicBuffer();
   }
-  
+
 #if AVC_SYNTAX
   if( streamSyntaxFile.is_open() )
@@ -816,10 +967,9 @@
   xDeleteBuffer();
   xDestroyLib();
-  
+
   printRateSummary();
 
   return;
 }
-
 
 Void TAppEncTop::printOutSummary()
@@ -843,5 +993,5 @@
     m_gcAnalyzeAll[layer].printOut('a', layer);
   }
-    
+
   printf( "\n\nI Slices--------------------------------------------------------\n" );
   printf( "\tTotal Frames |  "   "Bitrate    "  "Y-PSNR    "  "U-PSNR    "  "V-PSNR \n" );
@@ -850,5 +1000,5 @@
     m_gcAnalyzeI[layer].printOut('i', layer);
   }
-    
+
   printf( "\n\nP Slices--------------------------------------------------------\n" );
   printf( "\tTotal Frames |  "   "Bitrate    "  "Y-PSNR    "  "U-PSNR    "  "V-PSNR \n" );
@@ -857,5 +1007,5 @@
     m_gcAnalyzeP[layer].printOut('p', layer);
   }
-    
+
   printf( "\n\nB Slices--------------------------------------------------------\n" );
   printf( "\tTotal Frames |  "   "Bitrate    "  "Y-PSNR    "  "U-PSNR    "  "V-PSNR \n" );
@@ -878,19 +1028,19 @@
   TComPicYuv*       pcPicYuvOrg = new TComPicYuv;
   TComPicYuv*       pcPicYuvRec = NULL;
-  
+
   // initialize internal class & member variables
   xInitLibCfg();
   xCreateLib();
   xInitLib();
-  
+
   // main encoder loop
   Int   iNumEncoded = 0;
   Bool  bEos = false;
-  
+
   list<AccessUnit> outputAccessUnits; ///< list of access units to write out.  is populated by the encoding process
 
   // allocate original YUV buffer
   pcPicYuvOrg->create( m_iSourceWidth, m_iSourceHeight, m_uiMaxCUWidth, m_uiMaxCUHeight, m_uiMaxCUDepth );
-  
+
   while ( !bEos )
   {
@@ -900,15 +1050,23 @@
     // read input YUV file
     m_cTVideoIOYuvInputFile.read( pcPicYuvOrg, m_aiPad );
-    
+
     // increase number of received frames
     m_iFrameRcvd++;
-    
-    // check end of file
-    bEos = ( m_cTVideoIOYuvInputFile.isEof() == 1 ?   true : false  );
-    bEos = ( m_iFrameRcvd == m_iFrameToBeEncoded ?    true : bEos   );
-    
+
+    bEos = (m_iFrameRcvd == m_framesToBeEncoded);
+
+    Bool flush = 0;
+    // if end of file (which is only detected on a read failure) flush the encoder of any queued pictures
+    if (m_cTVideoIOYuvInputFile.isEof())
+    {
+      flush = true;
+      bEos = true;
+      m_iFrameRcvd--;
+      m_cTEncTop.setFramesToBeEncoded(m_iFrameRcvd);
+    }
+
     // call encoding function for one frame
-    m_cTEncTop.encode( bEos, pcPicYuvOrg, m_cListPicYuvRec, outputAccessUnits, iNumEncoded );
-    
+    m_cTEncTop.encode( bEos, flush ? 0 : pcPicYuvOrg, m_cListPicYuvRec, outputAccessUnits, iNumEncoded );
+
     // write bistream to file if necessary
     if ( iNumEncoded > 0 )
@@ -918,16 +1076,19 @@
     }
   }
+
+  m_cTEncTop.printSummary();
+
   // delete original YUV buffer
   pcPicYuvOrg->destroy();
   delete pcPicYuvOrg;
   pcPicYuvOrg = NULL;
-  
+
   // delete used buffers in encoder class
   m_cTEncTop.deletePicBuffer();
-  
+
   // delete buffers & classes
   xDeleteBuffer();
   xDestroyLib();
-  
+
   printRateSummary();
 
@@ -941,14 +1102,14 @@
 
 /**
- - application has picture buffer list with size of GOP
- - picture buffer list acts as ring buffer
- - end of the list has the latest picture
- .
- */
+- application has picture buffer list with size of GOP
+- picture buffer list acts as ring buffer
+- end of the list has the latest picture
+.
+*/
 #if SVC_EXTENSION
 Void TAppEncTop::xGetBuffer( TComPicYuv*& rpcPicYuvRec, UInt layer)
 {
   assert( m_iGOPSize > 0 );
-  
+
   // org. buffer
   if ( m_acListPicYuvRec[layer].size() == (UInt)m_iGOPSize )
@@ -960,5 +1121,5 @@
   {
     rpcPicYuvRec = new TComPicYuv;
-    
+
 #if SVC_UPSAMPLING
     rpcPicYuvRec->create( m_acLayerCfg[layer].getSourceWidth(), m_acLayerCfg[layer].getSourceHeight(), m_uiMaxCUWidth, m_uiMaxCUHeight, m_uiMaxCUDepth, NULL );
@@ -976,7 +1137,7 @@
   {
     TComList<TComPicYuv*>::iterator iterPicYuvRec  = m_acListPicYuvRec[layer].begin();
-    
+
     Int iSize = Int( m_acListPicYuvRec[layer].size() );
-    
+
     for ( Int i = 0; i < iSize; i++ )
     {
@@ -988,17 +1149,15 @@
 }
 
-
-
 Void TAppEncTop::xWriteRecon(UInt layer, Int iNumEncoded)
 {
   Int i;
-  
+
   TComList<TComPicYuv*>::iterator iterPicYuvRec = m_acListPicYuvRec[layer].end();
-  
+
   for ( i = 0; i < iNumEncoded; i++ )
   {
     --iterPicYuvRec;
   }
-  
+
   for ( i = 0; i < iNumEncoded; i++ )
   {
@@ -1006,21 +1165,20 @@
     if (!m_acLayerCfg[layer].getReconFile().empty())
     {
-      m_acTVideoIOYuvReconFile[layer].write( pcPicYuvRec, m_acLayerCfg[layer].getCropLeft(), m_acLayerCfg[layer].getCropRight(), 
-        m_acLayerCfg[layer].getCropTop(), m_acLayerCfg[layer].getCropBottom() );
-    }
-  }
-}
-
+      m_acTVideoIOYuvReconFile[layer].write( pcPicYuvRec, m_acLayerCfg[layer].getConfLeft(), m_acLayerCfg[layer].getConfRight(), 
+        m_acLayerCfg[layer].getConfTop(), m_acLayerCfg[layer].getConfBottom() );
+    }
+  }
+}
 
 Void TAppEncTop::xWriteStream(std::ostream& bitstreamFile, Int iNumEncoded, const std::list<AccessUnit>& accessUnits)
 {
   Int i;
-  
+
   list<AccessUnit>::const_iterator iterBitstream = accessUnits.begin();
-  
+
   for ( i = 0; i < iNumEncoded; i++ )
   {
     const AccessUnit& au = *(iterBitstream++);
-    const vector<unsigned>& stats = writeAnnexB(bitstreamFile, au);
+    const vector<UInt>& stats = writeAnnexB(bitstreamFile, au);
     rateStatsAccum(au, stats);
   }
@@ -1031,5 +1189,5 @@
 {
   assert( m_iGOPSize > 0 );
-  
+
   // org. buffer
   if ( m_cListPicYuvRec.size() == (UInt)m_iGOPSize )
@@ -1041,5 +1199,5 @@
   {
     rpcPicYuvRec = new TComPicYuv;
-    
+
     rpcPicYuvRec->create( m_iSourceWidth, m_iSourceHeight, m_uiMaxCUWidth, m_uiMaxCUHeight, m_uiMaxCUDepth );
 
@@ -1051,7 +1209,7 @@
 {
   TComList<TComPicYuv*>::iterator iterPicYuvRec  = m_cListPicYuvRec.begin();
-  
+
   Int iSize = Int( m_cListPicYuvRec.size() );
-  
+
   for ( Int i = 0; i < iSize; i++ )
   {
@@ -1060,21 +1218,21 @@
     delete pcPicYuvRec; pcPicYuvRec = NULL;
   }
-  
+
 }
 
 /** \param iNumEncoded  number of encoded frames
- */
+*/
 Void TAppEncTop::xWriteOutput(std::ostream& bitstreamFile, Int iNumEncoded, const std::list<AccessUnit>& accessUnits)
 {
   Int i;
-  
+
   TComList<TComPicYuv*>::iterator iterPicYuvRec = m_cListPicYuvRec.end();
   list<AccessUnit>::const_iterator iterBitstream = accessUnits.begin();
-  
+
   for ( i = 0; i < iNumEncoded; i++ )
   {
     --iterPicYuvRec;
   }
-  
+
   for ( i = 0; i < iNumEncoded; i++ )
   {
@@ -1082,9 +1240,9 @@
     if (m_pchReconFile)
     {
-      m_cTVideoIOYuvReconFile.write( pcPicYuvRec, m_cropLeft, m_cropRight, m_cropTop, m_cropBottom );
+      m_cTVideoIOYuvReconFile.write( pcPicYuvRec, m_confLeft, m_confRight, m_confTop, m_confBottom );
     }
 
     const AccessUnit& au = *(iterBitstream++);
-    const vector<unsigned>& stats = writeAnnexB(bitstreamFile, au);
+    const vector<UInt>& stats = writeAnnexB(bitstreamFile, au);
     rateStatsAccum(au, stats);
   }
@@ -1093,10 +1251,10 @@
 
 /**
- *
- */
-void TAppEncTop::rateStatsAccum(const AccessUnit& au, const std::vector<unsigned>& annexBsizes)
+*
+*/
+void TAppEncTop::rateStatsAccum(const AccessUnit& au, const std::vector<UInt>& annexBsizes)
 {
   AccessUnit::const_iterator it_au = au.begin();
-  vector<unsigned>::const_iterator it_stats = annexBsizes.begin();
+  vector<UInt>::const_iterator it_stats = annexBsizes.begin();
 
   for (; it_au != au.end(); it_au++, it_stats++)
@@ -1104,5 +1262,4 @@
     switch ((*it_au)->m_nalUnitType)
     {
-#if NAL_UNIT_TYPES_J1003_D7
     case NAL_UNIT_CODED_SLICE_TRAIL_R:
     case NAL_UNIT_CODED_SLICE_TRAIL_N:
@@ -1117,16 +1274,8 @@
     case NAL_UNIT_CODED_SLICE_IDR_N_LP:
     case NAL_UNIT_CODED_SLICE_CRA:
+    case NAL_UNIT_CODED_SLICE_RADL_N:
     case NAL_UNIT_CODED_SLICE_DLP:
+    case NAL_UNIT_CODED_SLICE_RASL_N:
     case NAL_UNIT_CODED_SLICE_TFD:
-#else
-    case NAL_UNIT_CODED_SLICE:
-    case NAL_UNIT_CODED_SLICE_TFD:
-    case NAL_UNIT_CODED_SLICE_TLA:
-    case NAL_UNIT_CODED_SLICE_CRA:
-    case NAL_UNIT_CODED_SLICE_CRANT:
-    case NAL_UNIT_CODED_SLICE_BLA:
-    case NAL_UNIT_CODED_SLICE_BLANT:
-    case NAL_UNIT_CODED_SLICE_IDR:
-#endif
     case NAL_UNIT_VPS:
     case NAL_UNIT_SPS:
@@ -1145,7 +1294,7 @@
 {
 #if SVC_EXTENSION
-  double time = (double) m_iFrameRcvd / m_acLayerCfg[m_numLayers-1].getFrameRate();
+  Double time = (Double) m_iFrameRcvd / m_acLayerCfg[m_numLayers-1].getFrameRate();
 #else
-  double time = (double) m_iFrameRcvd / m_iFrameRate;
+  Double time = (Double) m_iFrameRcvd / m_iFrameRate;
 #endif
   printf("Bytes written to file: %u (%.3f kbps)\n", m_totalBytes, 0.008 * m_totalBytes / time);
Index: trunk/source/App/TAppEncoder/TAppEncTop.h
===================================================================
--- trunk/source/App/TAppEncoder/TAppEncTop.h	(revision 55)
+++ trunk/source/App/TAppEncoder/TAppEncTop.h	(revision 125)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
- * Copyright (c) 2010-2012, ITU/ISO/IEC
+ * Copyright (c) 2010-2013, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -73,9 +73,9 @@
   TComList<TComPicYuv*>      m_cListPicYuvRec;              ///< list of reconstruction YUV files
 #endif
-
+  
   Int                        m_iFrameRcvd;                  ///< number of received frames
   
-  unsigned m_essentialBytes;
-  unsigned m_totalBytes;
+  UInt m_essentialBytes;
+  UInt m_totalBytes;
 protected:
   // initialization
@@ -103,5 +103,5 @@
   Void xWriteOutput(std::ostream& bitstreamFile, Int iNumEncoded, const std::list<AccessUnit>& accessUnits); ///< write bitstream to file
 #endif
-  void rateStatsAccum(const AccessUnit& au, const std::vector<unsigned>& stats);
+  void rateStatsAccum(const AccessUnit& au, const std::vector<UInt>& stats);
   void printRateSummary();
   
@@ -116,7 +116,4 @@
   TEncTop&    getTEncTop  ()   { return  m_cTEncTop; }      ///< return encoder class pointer reference
 #endif
-
-
-
 };// END CLASS DEFINITION TAppEncTop
 
Index: trunk/source/App/TAppEncoder/encmain.cpp
===================================================================
--- trunk/source/App/TAppEncoder/encmain.cpp	(revision 55)
+++ trunk/source/App/TAppEncoder/encmain.cpp	(revision 125)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
- * Copyright (c) 2010-2012, ITU/ISO/IEC
+ * Copyright (c) 2010-2013, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -37,5 +37,10 @@
 
 #include <time.h>
+#include <iostream>
 #include "TAppEncTop.h"
+#include "TAppCommon/program_options_lite.h"
+
+using namespace std;
+namespace po = df::program_options_lite;
 
 //! \ingroup TAppEncoder
@@ -62,7 +67,15 @@
 
   // parse configuration
-  if(!cTAppEncTop.parseCfg( argc, argv ))
+  try
   {
-    cTAppEncTop.destroy();
+    if(!cTAppEncTop.parseCfg( argc, argv ))
+    {
+      cTAppEncTop.destroy();
+      return 1;
+    }
+  }
+  catch (po::ParseFailure& e)
+  {
+    cerr << "Error parsing option \""<< e.arg <<"\" with argument \""<< e.val <<"\"." << endl;
     return 1;
   }
Index: trunk/source/App/utils/convert_NtoMbit_YCbCr.cpp
===================================================================
--- trunk/source/App/utils/convert_NtoMbit_YCbCr.cpp	(revision 55)
+++ trunk/source/App/utils/convert_NtoMbit_YCbCr.cpp	(revision 125)
@@ -76,6 +76,6 @@
   TVideoIOYuv output;
 
-  input.open((char*)filename_in.c_str(), false, bitdepth_in, bitdepth_out);
-  output.open((char*)filename_out.c_str(), true, bitdepth_out, bitdepth_out);
+  input.open((char*)filename_in.c_str(), false, bitdepth_in, bitdepth_in, bitdepth_out, bitdepth_out);
+  output.open((char*)filename_out.c_str(), true, bitdepth_out, bitdepth_out, bitdepth_out, bitdepth_out);
 
   input.skipFrames(num_frames_skip, width, height);
